require "defines"

game.oninit(function()

	game.player.character.insert{name="iron-plate", count=8}
	game.player.character.insert{name="pistol", count=1}
	game.player.character.insert{name="basic-bullet-magazine", count=100}
	game.player.character.insert{name="ccmarker", count=64}
	game.player.character.insert{name="clearmarker", count=64}
	game.player.character.insert{name="upgrademarker", count=64}
	game.player.character.insert{name="pmarker", count=64}
	game.player.character.insert{name="wooden-chest", count=64}
	game.player.character.insert{name="small-electric-pole", count=32}
	game.player.character.insert{name="basic-inserter", count=64}
	game.player.character.insert{name="solar-panel", count=54}
	game.player.character.insert{name="nanobots", count=1024}
	game.player.character.insert{name="basic-transport-belt", count=128}
	game.player.character.insert{name="steam-engine", count=16}
	game.player.character.insert{name="boiler", count=32}
	game.player.character.insert{name="gun-turret", count=32}
	game.player.character.insert{name="lab", count=8}
	game.player.character.insert{name="pipe", count=64}
	game.player.character.insert{name="basic-mining-drill", count=32}
	game.player.character.insert{name="basic-transport-belt-to-ground", count=32}
	game.player.character.insert{name="pipe-to-ground", count=32}
	game.player.character.insert{name="basic-splitter", count=32}
	game.player.character.insert{name="straight-rail", count=32}
	game.player.character.insert{name="curved-rail", count=32}
	game.player.character.insert{name="field", count=32}
	game.player.character.insert{name="fertilizer", count=128}
	game.player.character.insert{name="coal", count=128}
	game.player.character.insert{name="car", count=1}


	if glob.treefarm == nil then
		glob.treefarm = {}													-- Namespace
			glob.treefarm.field = {}											-- stores fieldentity position etc
			glob.treefarm.tick = 0												-- general mod-tickcounter
	end
end)


game.onload(function()
	if glob.treefarm == nil then
		glob.treefarm = {}													-- Namespace
			glob.treefarm.field = {}
			glob.treefarm.tick = 0

	end
end)


game.onevent(defines.events.onentitydied, function(event)
	if event.entity.name == "field" then
		for k, field in ipairs(glob.treefarm.field) do
			if not field.isvalid() then
				table.remove(glob.treefarm.field, k)
				break
			end
		end
	end
end)


game.onevent(defines.events.onplayermineditem, function(event)
	if event.itemstack.name == "field" then
		for k, field in ipairs(glob.treefarm.field) do
			if not field.isvalid() then
				table.remove(glob.treefarm.field, k)
				break
			end
		end
	end
end)


game.onevent(defines.events.onbuiltentity, function(event)
	if event.createdentity.name == "field" then
		glob.treefarm.field[#glob.treefarm.field + 1] = event.createdentity
	end
end)


game.onevent(defines.events.ontick, function(event)

	glob.treefarm.tick = glob.treefarm.tick + 1

	if (glob.treefarm.tick % 60) == 0 then	
		for _, field in pairs(glob.treefarm.field) do
			local growchance = math.ceil(math.random()*100)
			if field.getitemcount("fertilizer") > 0 then growchance = growchance + 25 end			
			local growntrees = game.findentitiesfiltered{area = {field.position, {field.position.x + 7, field.position.y + 7}}, type="tree"}
			if (growchance > 95) and (#growntrees < 40) then
				local treeplaced = false					
				while (treeplaced~= true) do
					local growntree = {}					
					local treeposition ={}
					treeposition.x = math.floor(math.random()*7) + field.position.x + 1
					treeposition.y = math.floor(math.random()*7) + field.position.y + 1
					growntree = game.findentitiesfiltered{area = {treeposition, treeposition}, type="tree"}
					if growntree[1] == nil then
						game.createentity{name = "big-tree", position = treeposition}
						treeplaced = true
					end
				end -- (treeplaced~= true)
			end -- (growchance > 99) and (#growntrees < 40)
		end -- _, field in ipairs(glob.treefarm.field)
	end -- (glob.treefarm.tick % 60) == 0

	if ((glob.treefarm.tick + 30) % 60) == 0 then		
		for _, field in pairs(glob.treefarm.field) do
			local diechance = math.ceil(math.random()*100)			
			local growntrees = game.findentitiesfiltered{area = {field.position, {field.position.x + 7, field.position.y + 7}}, type="tree"}
			if (#growntrees > 10) and (diechance > 98) then
				growntrees[math.ceil(math.random()*#growntrees)].destroy()
			end -- (#growntrees > 10) and (diechance > 80)
		end -- _, field in ipairs(glob.treefarm.field)
	end -- ((glob.treefarm.tick + 30) % 60) == 0

	if (glob.treefarm.tick % 1200) == 0 then		
		for _, field in ipairs(glob.treefarm.field) do
			if field.getitemcount("fertilizer") > 0 then
				field.getinventory(1).remove{name = "fertilizer", count = 1}
			end
		end -- _, field in ipairs(glob.treefarm.field)
	end -- ((glob.treefarm.tick + 30) % 60) == 0

	if (glob.treefarm.tick % (300 + math.ceil(math.random()*300))) == 0 then		
		for _, field in pairs(glob.treefarm.field) do
			local growntrees = game.findentitiesfiltered{area = {field.position, {field.position.x + 7, field.position.y + 7}}, type="tree"}
			if #growntrees > 20 then
				local rnd_out = math.floor(math.random()*2)
				if rnd_out > 0 then
					if (field.getitemcount("fertilizer") > 0) and (field.getitemcount("raw-wood") <= 116) then
						field.getinventory(1).insert{name = "raw-wood", count = (4 * rnd_out)}
					elseif (field.getitemcount("fertilizer") == 0) and (field.getitemcount("raw-wood") <= 125) then
						field.getinventory(1).insert{name = "raw-wood", count = rnd_out}
					end
				end
			end
		end -- _, field in ipairs(glob.treefarm.field)
	end -- ((glob.treefarm.tick + 30) % 60) == 0
end)